#property copyright ""
#property link      ""

extern string Time_Start          = "15:00";  
extern string Time_End            = "17:50"; 
extern double Slippage            = 3;         //  
extern bool   usepercentofdeposit = True;
extern double Risk                = 5;
extern double Lot                 = 0.1;      //  
extern double LotExponent         = 1.6;       //        
extern int    Interval            = 70;        //       (     ,   )
extern int    Step2               = 70;        //    2
extern int    Step34              = 1;        //    3    3-4
extern int    Step57              = 1;        //    5    5-6-7
extern int    Step811             = 1;        //    8    8-9-10-11
extern int    Step12              = 1;        //    12
extern int    TakeProfit          = 20;        //  Profit     
extern bool   TypeTrade           = false;     // true;          .         .
                                              // false;    .         .
extern double Profit              = 4;        //  Profit     
extern int    ProfitPips          = 100;      ////  Profit     
extern bool   UseProfitPips       = true;     // Profit-ProfitPips
extern int    Timer               = 10;        //     ( )   .   Profit     .
extern double MAGICMA             = 123;       //   ()    
extern color  ColorBUY            = Blue;
extern color  ColorSELL           = Red;
int iDigitLot;                                //   
int iTicket;                                  //   

double dInterval;
double dStep2;
double dStep34;
double dStep57;
double dStep811;
double dStep12;
double dTakeProfit;

double dPrice;

bool FlagTEMP = true;
datetime daTimer;

// bool bFlagStart = true;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----

   bool bFlag = true;
      
      if(Digits==5 || Digits==3){
         if(NormalizeDouble(TakeProfit-((dTakeProfit/10)/Point),Digits)!=0){bFlag = false;}
      }else{
         if(NormalizeDouble(TakeProfit-(dTakeProfit/Point),Digits)!=0){bFlag = false;}   
      }
      
      
      dInterval = Interval;
      dStep2 = Step2;
      dStep34 = Step34;
      dStep57 = Step57;
      dStep811 = Step811;
      dStep12 = Step12;
      dTakeProfit = TakeProfit;
      
      if(Digits==5 || Digits==3){
         dInterval = dInterval*10;
         dStep2 = dStep2*10;
         dStep34 = dStep34*10;
         dStep57 = dStep57*10;
         dStep811 = dStep811*10;
         dStep12 = dStep12*10;
         dTakeProfit = dTakeProfit*10;
      }
      
      iDigitLot = InfoGetLotDigit(Symbol());
      InfoChangeToDigit(Symbol(), dInterval);
      InfoChangeToDigit(Symbol(), dStep2);
      InfoChangeToDigit(Symbol(), dStep34);
      InfoChangeToDigit(Symbol(), dStep57);
      InfoChangeToDigit(Symbol(), dStep811);
      InfoChangeToDigit(Symbol(), dStep12);
      InfoChangeToDigit(Symbol(), dTakeProfit);
      
      FlagTEMP = true;
      
      Timer = Timer*60;
      daTimer = TimeCurrent();
      
      double iBuy = OrdersGetOpenLot(Symbol(), OP_BUY, MAGICMA, "", 0, 0);
      double iSell = OrdersGetOpenLot(Symbol(), OP_SELL, MAGICMA, "", 0, 0);
      
      if(iBuy > 0 && iSell > 0){
         SendNewOrders(0,false);
      }else{
         if((iBuy > 0 && iSell <= 0) || (iBuy <= 0 && iSell > 0)){
            if(bFlag==false){
               
               double dblInfo[];
               string strInfo[];
               
               if(OrdersGetLastOpenInfo(Symbol(),-1,MAGICMA,"",dblInfo,strInfo)==true){
                  
                  double dTP = 0;
                  
                  if(dblInfo[1]==OP_BUY || dblInfo[1]==OP_BUYSTOP){dTP = NormalizeDouble(dblInfo[3] + dTakeProfit,Digits);}
                  if(dblInfo[1]==OP_SELL || dblInfo[1]==OP_SELLSTOP){dTP = NormalizeDouble(dblInfo[3] - dTakeProfit,Digits);}
                  
                  int iTic = dblInfo[0];
                  
                  OrderModify(iTic,dblInfo[3],0,dTP,0,clrNONE);
                  
               }else{
                  Print("!      .");
               }
            }
         }   
      }
      
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
  if(usepercentofdeposit) Lot=GetLot();
//----
      
      double iBuy = OrdersGetOpenLot(Symbol(), OP_BUY, MAGICMA, "", 0, 0);
      double iSell = OrdersGetOpenLot(Symbol(), OP_SELL, MAGICMA, "", 0, 0);
      double iBuyStop = OrdersGetOpenLot(Symbol(), OP_BUYSTOP, MAGICMA, "", 0, 0);
      double iSellStop = OrdersGetOpenLot(Symbol(), OP_SELLSTOP, MAGICMA, "", 0, 0);
      
      int OrdTyp = 0;
      double dLot = 0;
      double dLastPrice = 0;
      int iLastTicket = 0;
      double dLotMe = 0; 
      double dLastPriceMe = 0;
      double dTPP = 0;
      double dTPMe = 0;
      double dSL = 0;
      double dSLclear = 0;

      datetime TimeStart = StrToTime(StringConcatenate(Day(),".",Month(),".",Year()," ",Time_Start,":00"));
      datetime TimeEnd   = StrToTime(StringConcatenate(Day(),".",Month(),".",Year()," ",Time_End,":00"));
      datetime TimeCur   = TimeCurrent();               
               
            // 33 - all, 0 - buy, 2 - sell, 11 - buystop and buylimit, 21 - sellstop and selllimit,
               
               if(iBuy <= 0 && iSell <= 0 && iSellStop > 0 && iBuyStop <= 0){
                  LastTicket(OP_SELLSTOP, dLot, dLastPriceMe, iLastTicket,dTPP,dSLclear);
                  
                  OrdersClose(21,MAGICMA,true,Symbol(),"",clrNONE);

                  if(TimeCur >= TimeStart && TimeCur < TimeEnd){                  
                     if(TypeTrade==false){
                        SendStart(0,0,true);
                     }else{
                        SendStart(OP_SELLSTOP,dLastPriceMe,false);   
                     }
                     return;
                  }
               }else{
               if(iBuy <= 0 && iSell <= 0 && iBuyStop > 0 && iSellStop <= 0){
                  LastTicket(OP_BUYSTOP, dLot, dLastPriceMe, iLastTicket,dTPP,dSLclear);
                  OrdersClose(11,MAGICMA,true,Symbol(),"",clrNONE);
                    
                  if(TimeCur >= TimeStart && TimeCur < TimeEnd){
                     if(TypeTrade==false){
                        SendStart(0,0,true);
                     }else{
                        SendStart(OP_BUYSTOP,dLastPriceMe,false);   
                     }
                     return;
                  }
               }
               }
               
               
               double dTPpips = 0;
               
               if((iBuy > 0 && iSell <= 0 && iBuy==iSellStop) || (iBuy > 0 && iSell <= 0 && iSellStop <= 0 && iBuyStop <= 0)){
                  LastTicket(OP_BUY, dLotMe, dLastPrice, iLastTicket,dTPMe,dSLclear);
                  dPrice = NormalizeDouble(dLastPrice - dStep2,Digits);
                  OrdersClose(21,MAGICMA,true,Symbol(),"",clrNONE);
                  OrdersOpen(4,NormalizeDouble(dLotMe*3,iDigitLot),dPrice,Symbol(),"#2",0,0,iDigitLot,Slippage, MAGICMA,iTicket,ColorSELL);
                  return;
               }else{
                  if((iBuy <= 0 && iSell > 0 && iSell==iBuyStop) || (iBuy <= 0 && iSell > 0 && iSellStop <= 0 && iBuyStop <= 0)){
                     LastTicket(OP_SELL, dLotMe, dLastPrice, iLastTicket,dTPMe,dSLclear);
                     dPrice = NormalizeDouble(dLastPrice + dStep2,Digits);
                     OrdersClose(11,MAGICMA,true,Symbol(),"",clrNONE);
                     OrdersOpen(3,NormalizeDouble(dLotMe*3,iDigitLot),dPrice,Symbol(),"#2",0,0,iDigitLot,Slippage, MAGICMA,iTicket,ColorBUY);
                     return;   
                  }
               }   
                  
               if(iBuy > 0 && iSell > 0 && iSellStop <= 0 && iBuyStop <= 0){
                  if(iBuy > iSell){
                     SendNewOrders(OP_BUY,true);
                  }else{
                     SendNewOrders(OP_SELL,true);   
                  }
               }
            
            iBuy = OrdersGetOpenLot(Symbol(), OP_BUY, MAGICMA, "", 0, 0);
            iSell = OrdersGetOpenLot(Symbol(), OP_SELL, MAGICMA, "", 0, 0);
            iBuyStop = OrdersGetOpenLot(Symbol(), OP_BUYSTOP, MAGICMA, "", 0, 0);
            iSellStop = OrdersGetOpenLot(Symbol(), OP_SELLSTOP, MAGICMA, "", 0, 0);      

            //33 - all, 0 - buy, 2 - sell, 11 - buystop and buylimit, 21 - sellstop and selllimit, 
            //31 - selllimit and buylimit, 41 - buystop and sellstop
            //51 - buylimit and sellstop, 61 - selllimit and buystop
            if(iBuy <= 0 && iSell <= 0 && iSellStop == Lot && iBuyStop == Lot && TimeCur >= TimeEnd){
               OrdersClose(33,MAGICMA,true,Symbol(),"",clrNONE);
            }

            if(iBuy <= 0 && iSell <= 0 && iSellStop <= 0 && iBuyStop <= 0 && TimeCur >= TimeStart && TimeCur < TimeEnd){
               SendStart(0,0,true);
            }else{
               if(iBuy > 0 && iSell > 0){
                  if(TimeCurrent() > daTimer+Timer){
                     SendNewOrders(0,false);
                     daTimer = TimeCurrent();
                  }
               }else{
                  if(iBuy <= 0 && iSell <= 0){
                     if((iSellStop > 0 && iBuyStop <= 0) || (iSellStop <= 0 && iBuyStop > 0)){
                        if(TimeCurrent() > daTimer+Timer){
                        
                           double dblInfo[];
                           string strInfo[];
               
                           if(OrdersGetLastOpenInfo(Symbol(),50,MAGICMA,"",dblInfo,strInfo)==true){
                            //  if(dblInfo[6]!=Lot){
                                 OrdersClose(33,MAGICMA,true,Symbol(),"",clrNONE);   
                            //  }
                           }else{
                              Print("!     !");
                           }
                           daTimer = TimeCurrent();
                        }   
                     }
                  }   
               
               }
            }
//----
   return(0);
  }
//+------------------------------------------------------------------+
double GetTPSL(int & iTypeGT, double dLotGT, double dPriceGT){
   
      double dPosition = 0;
      double dProfit = 0;
      
      double dSpeadSS = MarketInfo(Symbol(),MODE_SPREAD);
      InfoChangeToDigit(Symbol(), dSpeadSS);
   
            for(int A=OrdersTotal()-1;A>=0;A--){
               OrderSelect(A,SELECT_BY_POS);
               if(OrderMagicNumber()==MAGICMA && OrderSymbol()==Symbol()){
                  if(OrderType()==OP_BUY){
                     dPosition = dPosition + OrderLots();
                     dProfit = dProfit + OrderProfit()+OrderSwap()+OrderCommission();
                  }
                  if(OrderType()==OP_SELL){
                     dPosition = dPosition - OrderLots();
                     dProfit = dProfit + OrderProfit()+OrderSwap()+OrderCommission();
                  }
               }
            }
            
            double dCostPip = InfoGetPriceOfPoint(Symbol());
            double dPips = 0;
            
            if(dPosition < 0){
              if(dProfit < 0){
                  dProfit = Profit + (dProfit*(-1));
               }else{
                  dProfit = Profit - dProfit;
               }
               dPips = (dProfit / (dCostPip * (dPosition*(-1))));
               InfoChangeToDigit(Symbol(), dPips);
               iTypeGT = OP_SELL;
               if(dPips < 0){dPips = dPips*(-1);}
               dPips = (Ask - dPips);
               if(UseProfitPips) dPips=Ask-ProfitPips*Point;
               return(dPips); 
            }
            
            if(dPosition > 0){
               if(dProfit < 0){
                  dProfit = Profit + (dProfit*(-1));
               }else{
                  dProfit = Profit - dProfit;
               }
               dPips = (dProfit / (dCostPip * dPosition));
               InfoChangeToDigit(Symbol(), dPips);
               iTypeGT = OP_BUY;
               if(dPips < 0){dPips = dPips*(-1);}
               dPips = (Bid + dPips);
               if(UseProfitPips) dPips=Bid+ProfitPips*Point;
               return(dPips); 
            }
      
}
//+------------------------------------------------------------------+
void SendStart(int iTyp, double dPr, bool bFlag){
     // 1 - Buy, 2 - Sell, 3 - BuyStop, 4 - SellStop

     double dSLss = 0;
     double dSpeadSS = MarketInfo(Symbol(),MODE_SPREAD);
     InfoChangeToDigit(Symbol(), dSpeadSS);
       
         if(bFlag==true){
      
            dPrice = NormalizeDouble(Ask + (dInterval/2),Digits);     
            OrdersOpen(3,Lot,dPrice,Symbol(),"#1",0,dTakeProfit,iDigitLot,Slippage, MAGICMA,iTicket,ColorBUY);
            dPrice = NormalizeDouble(Ask - (dInterval/2),Digits);
            OrdersOpen(4,Lot,dPrice,Symbol(),"#1",0,dTakeProfit,iDigitLot,Slippage, MAGICMA,iTicket,ColorSELL);
            
         }else{
         
            if(iTyp==OP_SELLSTOP){
             
               dSLss = NormalizeDouble((Ask - dPr) + dTakeProfit + dSpeadSS,Digits);
               OrdersOpen(1,Lot,Ask,Symbol(),"#1",dSLss,dTakeProfit,iDigitLot,Slippage, MAGICMA,iTicket,ColorBUY);
               dPr = NormalizeDouble(Ask - dStep2,Digits);
               OrdersOpen(4,NormalizeDouble(Lot*3,iDigitLot),dPr,Symbol(),"#2",dSLss,dTakeProfit,iDigitLot,Slippage, MAGICMA,iTicket,ColorSELL);
            }
            
            if(iTyp==OP_BUYSTOP){
             
               dSLss = NormalizeDouble((dPr - Bid) + dTakeProfit + dSpeadSS,Digits);
               OrdersOpen(2,Lot,Bid,Symbol(),"#1",dSLss,dTakeProfit,iDigitLot,Slippage, MAGICMA,iTicket,ColorSELL);
               dPr = NormalizeDouble(Bid + dStep2,Digits);
               OrdersOpen(3,NormalizeDouble(Lot*3,iDigitLot),dPr,Symbol(),"#2",dSLss,dTakeProfit,iDigitLot,Slippage, MAGICMA,iTicket,ColorBUY);
            }
         
         }   

}  
//+------------------------------------------------------------------+
void SendNewOrders(int iTypeSNO, bool bFlag){
      
    int iBuy = OrdersGetCount(Symbol(),OP_BUY, MAGICMA, "", 0, 0);
    int iSell = OrdersGetCount(Symbol(),OP_SELL, MAGICMA, "", 0, 0);
    
    double dSpeadMe = MarketInfo(Symbol(),MODE_SPREAD);
    InfoChangeToDigit(Symbol(), dSpeadMe);
    double dStepMe = 0;
    int iSum = iBuy + iSell +1;
    double dLPrice = 0;
    double dLPriceMe = 0;
    double dLotSNO = 0;
    double dLotSNOme = 0;
    double dSLsno = 0;
    double dTPsno = 0;
    double dTPsnoMe = 0;
    int iLTic = 0;
    int iLTicMe = 0;
    double dSLons = 0;
    double dSLonsMe = 0;
    double dTPons = 0;
    double dTPpips = 0;
    if(iSum > 2 && iSum < 5){dStepMe = dStep34;}
    if(iSum > 4 && iSum < 8){dStepMe = dStep57;}
    if(iSum > 7 && iSum < 12){dStepMe = dStep811;}
    if(iSum > 11){dStepMe = dStep12;}
    
    double dTPBUY = 0;
    double dSLBUY = 0;
    double dTPSELL = 0;
    double dSLSELL = 0;
    int iTYPE = 0;
    
    double dTPPP = 0;
    double dSLLL = 0;
    
      if(bFlag==true){
            
         if(iTypeSNO==OP_BUY){
            LastTicket(OP_BUY, dLotSNO, dLPrice, iLTic,dTPsno,dSLons);
            LastTicket(OP_SELL, dLotSNOme, dLPriceMe, iLTicMe,dTPsnoMe,dSLonsMe);
            
            dPrice = NormalizeDouble(dLPriceMe - dStepMe, Digits);
            OrdersOpen(4,NormalizeDouble(dLotSNO*LotExponent,iDigitLot),dPrice,Symbol(),"#"+iSum,0,0,iDigitLot,Slippage, MAGICMA,iTicket,ColorSELL);
         }
         
         if(iTypeSNO==OP_SELL){
         
            LastTicket(OP_SELL, dLotSNO, dLPrice, iLTic,dTPsno,dSLons);
            LastTicket(OP_BUY, dLotSNOme, dLPriceMe, iLTicMe,dTPsnoMe,dSLonsMe);
            
            dPrice = NormalizeDouble(dLPriceMe + dStepMe, Digits);
            OrdersOpen(3,NormalizeDouble(dLotSNO*LotExponent,iDigitLot),dPrice,Symbol(),"#"+iSum,0,0,iDigitLot,Slippage, MAGICMA,iTicket,ColorBUY);
         }
         
      }   
            
            dTPpips = GetTPSL(iTYPE,dLotSNO*2,dPrice);
            
            if(iTYPE==OP_BUY){
               dTPBUY = dTPpips;
               dSLSELL = dTPpips + dSpeadMe;
            }
            if(iTYPE==OP_SELL){
               dTPSELL = dTPpips;
               dSLBUY = dTPpips - dSpeadMe;
            }
            
            for(int A=OrdersTotal()-1;A>=0;A--){
               OrderSelect(A,SELECT_BY_POS);
               if(OrderMagicNumber()==MAGICMA && OrderSymbol()==Symbol()){
                  if(OrderType()==OP_BUY){
                     if(iTYPE==OP_BUY){
                        if(NormalizeDouble(dTPBUY-OrderTakeProfit(),Digits)!=0){
                           OrderModify(OrderTicket(),OrderOpenPrice(),0,dTPBUY,0,clrNONE);
                        }   
                     }else{
                        if(iTYPE==OP_SELL){
                           if(NormalizeDouble(dSLBUY-OrderStopLoss(),Digits)!=0){
                              OrderModify(OrderTicket(),OrderOpenPrice(),dSLBUY,0,0,clrNONE);
                           }   
                        }
                     }
                  }else{
                     if(OrderType()==OP_SELL){
                        if(iTYPE==OP_SELL){
                           if(NormalizeDouble(dTPSELL-OrderTakeProfit(),Digits)!=0){
                              OrderModify(OrderTicket(),OrderOpenPrice(),0,dTPSELL,0,clrNONE);
                           }   
                        }else{
                           if(iTYPE==OP_BUY){
                              if(NormalizeDouble(dSLSELL-OrderStopLoss(),Digits)!=0){
                                 OrderModify(OrderTicket(),OrderOpenPrice(),dSLSELL,0,0,clrNONE);
                              }   
                           }
                        }
                     }
                  }
               }
            }
            
}
//+------------------------------------------------------------------+
void LastTicket(int OrdTyp, double & dLot,double & dLastPrice, int & iLastTicket, double & dTP, double & dSL){

   datetime daTimeLast = 0;
         
            for(int A=OrdersTotal()-1;A>=0;A--){
               OrderSelect(A,SELECT_BY_POS);
               if(OrderMagicNumber()==MAGICMA && OrderSymbol()==Symbol() && OrderType()==OrdTyp){
                  if(OrderOpenTime() > daTimeLast){
                     daTimeLast = OrderOpenTime();
                     iLastTicket = OrderTicket();
                     dLot = OrderLots();
                     dLastPrice = OrderOpenPrice(); 
                     dTP = OrderTakeProfit();
                     dSL = OrderStopLoss();    
                  }   
               }
            }

}
//+------------------------------------------------------------------+
//        (   )
////// :
// _symbol     -     ("" -    )
// _type_order -    (-1 -  )
//                :
//               99 -  
//               10 - Buy  Sell
//               50 -  (BuyStop, BuyLimit, SellStop, SellLimit)
//               51 - BuyStop  BuyLimit
//               52 - SellStop  SellLimit
//               53 - BuyStop  SellStop
//               54 - BuyLimit  SellLimit
// _magic      -    (-1 -      )
// _comment    -       ("" -      )
//////   ():
// dblInfo -    (   ):
//           0 - OrderTicket,   
//           1 - OrderType,  
//           2 - OrderOpenTime,   
//           3 - OrderOpenPrice,   
//           4 - OrderStopLoss,       
//           5 - OrderTakeProfit,       
//           6 - OrderLots,  
//           7 - OrderMagicNumber,   
//           8 - OrderProfit,    
//           9 - OrderCommission,    
//           10- OrderSwap,  
// strInfo -   :
//           0 - OrderSymbol,     
//           1 - OrderComment,   
//-// true   , false   
bool OrdersGetLastOpenInfo(string symbol, int typeorder, int magic, string comment, double& dblInfo[], string& strInfo[]){    bool res = false; datetime time = 0; int ticket = 0; for(int i=OrdersTotal()-1;i>=0;i--){ if(OrderSelect(i,SELECT_BY_POS)){ if((time==0 || OrderOpenTime()>time) && (symbol=="" || OrderSymbol()==symbol) && (typeorder==-1 || InfoisTypeOrdPartOfGroup(OrderType(), typeorder)) && (magic==-1 || magic==OrderMagicNumber()) && (comment=="" || StringFind(OrderComment(),comment)!=-1)) { time = OrderOpenTime(); ticket = OrderTicket(); } } } if(time>0){ if(OrderSelect(ticket,SELECT_BY_TICKET)){ ArrayResize(dblInfo,11); ArrayInitialize(dblInfo,0); ArrayResize(strInfo,2); dblInfo[0] = OrderTicket(); dblInfo[1] = OrderType(); dblInfo[2] = OrderOpenTime(); dblInfo[3] = OrderOpenPrice(); dblInfo[4] = OrderStopLoss(); dblInfo[5] = OrderTakeProfit(); dblInfo[6] = OrderLots(); dblInfo[7] = OrderMagicNumber(); dblInfo[8] = OrderProfit(); dblInfo[9] = OrderCommission(); dblInfo[10]= OrderSwap(); strInfo[0] = OrderSymbol(); strInfo[1] = OrderComment(); res = true; } } if(!res){ ArrayResize(dblInfo,0); ArrayResize(strInfo,0); } return(res); }
//+------------------------------------------------------------------+
//          
// _type_order -   (Buy, Sell, BuyStop, SellStop, BuyLimit, SellLimit)
// _type_group -  :
//               99 -  
//               10 - Buy  Sell
//               50 -  (BuyStop, BuyLimit, SellStop, SellLimit)
//               51 - BuyStop  BuyLimit
//               52 - SellStop  SellLimit
//               53 - BuyStop  SellStop
//               54 - BuyLimit  SellLimit
bool InfoisTypeOrdPartOfGroup(int typeorder, int typegroup){ if(typeorder < 0) return(false); bool res = false; switch(typeorder){ case OP_BUY: switch(typegroup){ case 99: case 10: case OP_BUY: res = true; } break; case OP_SELL: switch(typegroup){ case 99: case 10: case OP_SELL: res = true; } break; case OP_BUYSTOP: switch(typegroup){ case 99: case 50: case 51: case 53: case OP_BUYSTOP: res = true; } break; case OP_SELLSTOP: switch(typegroup){ case 99: case 50: case 52: case 53: case OP_SELLSTOP: res = true; } break; case OP_BUYLIMIT: switch(typegroup){ case 99: case 50: case 51: case 54: case OP_BUYLIMIT: res = true; } break; case OP_SELLLIMIT: switch(typegroup){ case 99: case 50: case 52: case 54: case OP_SELLLIMIT: res = true; } break; } return(res); }
//+------------------------------------------------------------------+
//              1 
double InfoGetPriceOfPoint(string B){RefreshRates();double S = 0; if(B!=""){S = MarketInfo(B,MODE_TICKVALUE)/(MarketInfo(B,MODE_TICKSIZE)/MarketInfo(B,MODE_POINT));}return(S);}
//+------------------------------------------------------------------+
//       -   
// symbol -      
// v -    ,   
//--//   
void InfoChangeToDigit(string symbol, double& v) { v *= MarketInfo(symbol,MODE_TICKSIZE); return; }
//+------------------------------------------------------------------+
//   - 
// _symbol -  ("",  )
// _type   -   (-1,   )
//            :
//           99 -  
//           10 - Buy  Sell
//           50 -  (BuyStop, BuyLimit, SellStop, SellLimit)
//           51 - BuyStop  BuyLimit
//           52 - SellStop  SellLimit
//           53 - BuyStop  SellStop
//           54 - BuyLimit  SellLimit
// _magic  -     (-1,    )
// _comm   -       ("",   )
// minOpenTime -          (0 -  )
// maxOpenTime -          (0 -  )
//-//  -    0
int OrdersGetCount(string symbol, int type, int magic, string comm, datetime minOpenTime, datetime maxOpenTime){ int iCount=0; if(OrdersTotal()<=0) return(0); for(int a1=OrdersTotal()-1;a1>=0;a1--){ if(OrderSelect(a1,SELECT_BY_POS)){ if((symbol=="" || symbol==OrderSymbol()) && (magic==-1 || magic==OrderMagicNumber()) && (comm=="" || StringFind(OrderComment(),comm)!=-1) &&  (minOpenTime==0 || OrderOpenTime()>=minOpenTime) && (maxOpenTime==0 || OrderOpenTime()<=maxOpenTime)){ if(type==99){ iCount++; }else{ switch(OrderType()){ case OP_BUY: if(type==OP_BUY || type==10) iCount++; break; case OP_BUYSTOP: if(type==OP_BUYSTOP || type==50 || type==51 || type==53) iCount++; break; case OP_BUYLIMIT: if(type==OP_BUYLIMIT || type==50 || type==51 || type==54) iCount++; break; case OP_SELL: if(type==OP_SELL || type==10) iCount++; break; case OP_SELLSTOP: if(type==OP_SELLSTOP || type==50 || type==52 || type==53) iCount++; break; case OP_SELLLIMIT: if(type==OP_SELLLIMIT || type==50 || type==52 || type==54) iCount++; break; } } } } } return(iCount); }
//+------------------------------------------------------------------+
//   -  
// _symbol -  ("",  )
// _type   -   (-1,   )
//            :
//           99 -  
//           10 - Buy  Sell
//           50 -  (BuyStop, BuyLimit, SellStop, SellLimit)
//           51 - BuyStop  BuyLimit
//           52 - SellStop  SellLimit
//           53 - BuyStop  SellStop
//           54 - BuyLimit  SellLimit
// _magic  -     (-1,    )
// _comm   -       ("",   )
// minOpenTime -          (0 -  )
// maxOpenTime -          (0 -  )
//-//  -    0
double OrdersGetOpenLot(string symbol, int type, int magic, string comm, datetime minOpenTime, datetime maxOpenTime){ int a1,ordertype; double lot=0; for(a1=OrdersTotal()-1;a1>=0;a1--){ if(OrderSelect(a1,SELECT_BY_POS)){ if((symbol=="" || OrderSymbol()==symbol) && (magic==-1 || OrderMagicNumber()==magic) && (comm=="" || StringFind(OrderComment(),comm)!=-1) && (minOpenTime==0 || OrderOpenTime()>=minOpenTime) && (maxOpenTime==0 || OrderOpenTime()<=maxOpenTime)){ if(type==99){lot +=OrderLots(); }else{ ordertype = OrderType(); if((type==OP_BUY       || type==10) && ordertype==OP_BUY) lot +=OrderLots(); if((type==OP_SELL      || type==10) && ordertype==OP_SELL)lot+=OrderLots(); if((type==OP_SELLSTOP  || type==50 || type==52 || type==53) && ordertype==OP_SELLSTOP) lot+=OrderLots(); if((type==OP_BUYSTOP   || type==50 || type==51 || type==53) && ordertype==OP_BUYSTOP)  lot+=OrderLots(); if((type==OP_SELLLIMIT || type==50 || type==52 || type==54) && ordertype==OP_SELLLIMIT)lot+=OrderLots(); if((type==OP_BUYLIMIT  || type==50 || type==51 || type==54) && ordertype==OP_BUYLIMIT) lot+=OrderLots(); } } } } return(lot); }
//+------------------------------------------------------------------+
//   
// symbol -      
//--// -     0
int InfoGetLotDigit(string symbol){ return(MathCeil(MathAbs(MathLog( MarketInfo(Symbol(), MODE_MINLOT) )/MathLog(10)))); }
//+------------------------------------------------------------------+
//   
// 1 - Buy, 2 - Sell, 3 - BuyStop, 4 - SellStop, 5 - BuyLimit, 6 - SellLimit
void OrdersOpen(int type_order, double Lots, double price, string SymbolSend, string Comm, double SL, double TP, int dlot, int slip, int mag, int& tick, color clr=clrNONE)
{int lerror130=0; double takeprofit, stoplosse;
switch(type_order){
  case 1 :
      while(true){
       if(IsTradeAllowed())
       {RefreshRates();          
          tick = OrderSend(SymbolSend,OP_BUY,NormalizeDouble(Lots,dlot),NormalizeDouble(MarketInfo(SymbolSend,MODE_ASK),MarketInfo(SymbolSend,MODE_DIGITS)),slip,0,0,Comm,mag,0,clr);
          if(tick==-1) { if(ErrorCheck(GetLastError(),lerror130)) return; }else{ break; }
          continue;
      } }
      if(tick!=-1 && (SL!=0 || TP!=0)){  
          while(true){
            if(IsTradeAllowed()){
              RefreshRates();
               if(OrderSelect(tick,SELECT_BY_TICKET)){                  
                  if(SL==0) { stoplosse = 0; }else{ stoplosse = OrderOpenPrice()-SL; }
                  if(TP==0) { takeprofit = 0;}else{ takeprofit= OrderOpenPrice()+TP; }
                 if(OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(stoplosse,MarketInfo(SymbolSend,MODE_DIGITS)),NormalizeDouble(takeprofit,MarketInfo(SymbolSend,MODE_DIGITS)),0)) break;
                 if(ErrorCheck(GetLastError(),lerror130)) break;
                 continue;                 
               }else{ Print("OrderSelectError "+GetLastError()); }
      } } }        
      break;
  case 2 :
      while(true){   
       if(IsTradeAllowed()){
          RefreshRates();
          tick = OrderSend(SymbolSend,OP_SELL,NormalizeDouble(Lots,dlot),NormalizeDouble(MarketInfo(SymbolSend,MODE_BID),MarketInfo(SymbolSend,MODE_DIGITS)),slip,0,0,Comm,mag,0,clr);
          if(tick==-1) { if(ErrorCheck(GetLastError(),lerror130)) return(-1); }else{ break; }
          continue;
      } }
      if(tick!=-1 && (SL!=0 || TP!=0)){  
          while(true){
            if(IsTradeAllowed()){
               RefreshRates();
               if(OrderSelect(tick,SELECT_BY_TICKET)){                  
                  if(SL==0) { stoplosse = 0; }else{ stoplosse = OrderOpenPrice()+SL; }
                  if(TP==0) { takeprofit = 0;}else{ takeprofit= OrderOpenPrice()-TP; }
                 if(OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(stoplosse,MarketInfo(SymbolSend,MODE_DIGITS)),NormalizeDouble(takeprofit,MarketInfo(SymbolSend,MODE_DIGITS)),0)) break;
                 if(ErrorCheck(GetLastError(),lerror130)) break;
                 continue;                 
               }else{ Print("OrderSelectError "+GetLastError()); }
      } } }        
     break;  
  case 3 :
      while(true){   
       if(IsTradeAllowed()){
          RefreshRates();
          if(SL==0) { stoplosse = 0; }else{ stoplosse = price-SL;}
          if(TP==0) { takeprofit = 0;}else{ takeprofit= price+TP;}
          tick = OrderSend(SymbolSend,OP_BUYSTOP,NormalizeDouble(Lots,dlot),NormalizeDouble(price,MarketInfo(SymbolSend,MODE_DIGITS)),slip,NormalizeDouble(stoplosse,MarketInfo(SymbolSend,MODE_DIGITS)),NormalizeDouble(takeprofit,MarketInfo(SymbolSend,MODE_DIGITS)),Comm,mag,0,clr);
          if(tick==-1){if(ErrorCheck(GetLastError(),lerror130)) break;}else{ break; }
          continue;   
      } }                
      break;
  case 4 :
      while(true){   
         if(IsTradeAllowed()){
            RefreshRates();             
             if(SL==0) { stoplosse = 0; }else{ stoplosse = price+SL;}
             if(TP==0) { takeprofit = 0;}else{ takeprofit= price-TP;}
             tick = OrderSend(SymbolSend,OP_SELLSTOP,NormalizeDouble(Lots,dlot),NormalizeDouble(price,MarketInfo(SymbolSend,MODE_DIGITS)),slip,NormalizeDouble(stoplosse,MarketInfo(SymbolSend,MODE_DIGITS)),NormalizeDouble(takeprofit,MarketInfo(SymbolSend,MODE_DIGITS)),Comm,mag,0,clr);
             if(tick==-1){if(ErrorCheck(GetLastError(),lerror130)) break;}else{ break; }
             continue;    
      } }   
     break; 
  case 5 :
      while(true){   
         if(IsTradeAllowed()){
            RefreshRates();             
             if(SL==0) { stoplosse = 0; }else{ stoplosse = price-SL;}
             if(TP==0) { takeprofit = 0;}else{ takeprofit= price+TP;}
             tick = OrderSend(SymbolSend,OP_BUYLIMIT,NormalizeDouble(Lots,dlot),NormalizeDouble(price,MarketInfo(SymbolSend,MODE_DIGITS)),slip,NormalizeDouble(stoplosse,MarketInfo(SymbolSend,MODE_DIGITS)),NormalizeDouble(takeprofit,MarketInfo(SymbolSend,MODE_DIGITS)),Comm,mag,0,clr);
             if(tick==-1){if(ErrorCheck(GetLastError(),lerror130)) break;}else{ break; }
             continue;    
      } }   
     break;
  case 6 :
      while(true){   
         if(IsTradeAllowed()){
            RefreshRates();             
             if(SL==0) { stoplosse = 0; }else{ stoplosse = price+SL;}
             if(TP==0) { takeprofit = 0;}else{ takeprofit= price-TP;}
             tick = OrderSend(SymbolSend,OP_SELLLIMIT,NormalizeDouble(Lots,dlot),NormalizeDouble(price,MarketInfo(SymbolSend,MODE_DIGITS)),slip,NormalizeDouble(stoplosse,MarketInfo(SymbolSend,MODE_DIGITS)),NormalizeDouble(takeprofit,MarketInfo(SymbolSend,MODE_DIGITS)),Comm,mag,0,clr);
             if(tick==-1){if(ErrorCheck(GetLastError(),lerror130)) break;}else{ break; }
             continue;    
      } }   
     break;
} }
//+------------------------------------------------------------------+
//   
//33 - all, 0 - buy, 2 - sell, 11 - buystop and buylimit, 21 - sellstop and selllimit, 
//31 - selllimit and buylimit, 41 - buystop and sellstop
//51 - buylimit and sellstop, 61 - selllimit and buystop
//_mag = -1 -    
//   
bool OrdersClose(int type, int mag, bool isMagic, string sSymbol, string scomm, color clr=clrNONE){
   if(OrdersTotal()<1) return(true);
   int ordertype, lerror130;
   for(int a1=OrdersTotal()-1;a1>=0;a1--){
      if(OrderSelect(a1,SELECT_BY_POS) && ((isMagic && OrderMagicNumber()==mag) || (!isMagic && OrderTicket()==mag) || mag==-1 )
                                       && ((sSymbol!="" && OrderSymbol()==sSymbol) || sSymbol=="") && (scomm=="" || StringFind(OrderComment(),scomm)!=-1) ){  
         ordertype = OrderType();         
         if((type==33 || type==0) && ordertype==OP_BUY) {
            while(true) {
               RefreshRates();                   
               if(IsTradeAllowed()){ 
                  if(OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(MarketInfo(OrderSymbol(),MODE_BID),MarketInfo(OrderSymbol(),MODE_DIGITS)),0,clr)) break; 
                  else if(ErrorCheck(GetLastError(),lerror130)) break;
               }               
         }  }                      
         if((type==33 || type==11 || type==41 || type==61) && ordertype==OP_BUYSTOP) {
            while(true) {
               RefreshRates();                                  
               if(IsTradeAllowed()){ 
                  if(OrderDelete(OrderTicket(),clr)) break; 
                  else if(ErrorCheck(GetLastError(),lerror130)) break;
               }               
         }   }                 
         if((type==33 || type==11 || type==31 || type==51) && ordertype==OP_BUYLIMIT) {
            while(true) {
               RefreshRates();                                  
               if(IsTradeAllowed()){ 
                  if(OrderDelete( OrderTicket(),clr)) break; 
                  else if(ErrorCheck(GetLastError(),lerror130)) break;
               }               
         }   }        
         if((type==33 || type==2) && ordertype==OP_SELL) {
            while(true) {
               RefreshRates();                   
               if(IsTradeAllowed()){ 
                  if(OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(MarketInfo(OrderSymbol(),MODE_ASK),MarketInfo(OrderSymbol(),MODE_DIGITS)),0,clr)) break; 
                  else if(ErrorCheck(GetLastError(),lerror130)) break;
               }
         }    }         
         if((type==33 || type==21 || type==41 || type==51) && ordertype==OP_SELLSTOP) {
            while(true) {
               RefreshRates();                   
               if(IsTradeAllowed()){ 
                  if(OrderDelete(OrderTicket(),clr)) break; 
                  else if(ErrorCheck(GetLastError(),lerror130)) break;
               }               
         }    }         
         if((type==33 || type==21 || type==31 || type==61) && ordertype==OP_SELLLIMIT) {
            while(true) {
               RefreshRates();                   
               if(IsTradeAllowed()){ 
                  if(OrderDelete(OrderTicket(),clr)) break; 
                  else if(ErrorCheck(GetLastError(),lerror130)) break;
               }               
   } } } } return(true); }   
//+------------------------------------------------------------------+
//   
bool ErrorCheck(int lerror64, int& error130){   
   
   Print("l_error_64 = "+lerror64);
   
   if(lerror64==0) return(true);
   
   switch(lerror64){
      case 4:  Print("  .  500 ...");       Sleep(500); return(false);
      case 6:  Print("   .  2 ...");         Sleep(2000);return(false);  
      case 129:Print("  .  500    ...");Sleep(500); return(false);
      case 135:Print(" .   ..");                      return(false);   
      case 136:Print(" .   ..");                   Sleep(1);   return(false);
      case 137:Print(" .  500 ...");                Sleep(500); return(false);
      case 138:Print(" . .");                                    return(false);
      case 141:Print("  .  1 ..");     Sleep(60000);return(false);
      case 146:Print("  .  ..");   Sleep(500); return(false);      
      case 130: if(error130==0) {Print(" .   ...");Sleep(1000);error130++;return(false); }else{ Print("   ."); return(true);}
      default: Print("   "+lerror64);                        return(true);
   }         
   return(true);
}
//+------------------------------------------------------------------+
double GetLot()
{
 double Free    =AccountFreeMargin();
 double OneLot =MarketInfo(Symbol(),MODE_MARGINREQUIRED);
 double MinLot =MarketInfo(Symbol(),MODE_MINLOT);
 double MaxLot =MarketInfo(Symbol(),MODE_MAXLOT);
 double Step    =MarketInfo(Symbol(),MODE_LOTSTEP);
 double lot     =MathFloor(Free*Risk/100/OneLot/Step)*Step;
 if(lot<MinLot) lot=MinLot;
 if(lot>MaxLot) lot=MaxLot;
 if(lot*OneLot>Free) return(0.0);
 
return(lot);
}  